#!/bin/env php -q
<?php
//
// File Cleaner Cron
// Copyright (c) 2008-2018 Nagios Enterprises, LLC. All rights reserved.
//

define("SUBSYSTEM", 1);

require_once(dirname(__FILE__).'/../html/config.inc.php');
require_once(dirname(__FILE__).'/../html/includes/common.inc.php');

init_cleaner();
do_cleaner_jobs();

// Connects to databases
function init_cleaner()
{
    $dbok = db_connect_all();
    if ($dbok == false) {
        echo "ERROR CONNECTING TO DATABASES!\n";
        exit();
    }
    return;
}

function do_cleaner_jobs()
{
    global $cfg;

    // Get checkpoint amounts to save
    $reg_num = get_option('num_snapshots', 10);
    $error_num = get_option('num_error_snapshots', 10);
    $ccm_num = get_option('num_ccm_snapshots', 10);

    // CLEANUP OLD NOM CHECKPOINTS
    // Keep only the most recent checkpoints
    $cmdline = $cfg['script_dir']."/nom_trim_checkpoints.sh --num $reg_num --enum $error_num --cnum $ccm_num";
    system($cmdline, $return_code);

    echo "----------------------------------\n";
    echo "Running callbacks:\n";

    // Misc cleanup functions
    $args = array(); 
    do_callbacks(CALLBACK_SUBSYS_CLEANER, $args); 

    echo "----------------------------------\n";

    update_sysstat();

    check_xi_file_integrity();
}

function update_sysstat()
{
    // Record our run in sysstat table
    $arr = array("last_check" => time());
    $sdata = serialize($arr);
    update_systat_value("cleaner", $sdata);
}
